
import java.applet.*;
import java.awt.*;

public class RonGaussDist extends Applet implements Runnable {
  int MAX=10;
  int counter;
  RandomFloatingGenerator randomFG;
  
 // Instance variables:
  mRectangle  bars[];
  Thread thread;      // a thread
  Image image;        // for double buffering

  // The value of Gaussian Dist Function between 0 and 5 increment by 0.5
  double PGD [] ={0.5,0.30855,0.15865,0.066804,0.022749,0.006209,0.001349,0.000232,0.000031,0.00000339,0.0};

  // Class method:
public void initObjects() {
  counter=0;
  
  /* initialize a rectangle */
  bars=new mRectangle[10];
  for (int i=0;i<10;i++){
    bars[i] = new mRectangle();
    bars[i].placeOrigin(getSize().width/2,getSize().height/2,-1);
    
  }
  
 /* initialize a circle */
  //  image = createImage(size().width, size().height);
  randomFG=new RandomFloatingGenerator();
  image =createImage( getSize().width, getSize().height );
  
  
}

  // Override java.applet.Applet.init:
public void init () {
  initObjects();
}

  // Override java.applet.Applet.start:
  public void start() {
    if (thread == null) {
      // Reinitialize:
      initObjects();
      thread = new Thread(this);
      thread.start();
    }
  }

  // Override java.applet.Applet.stop:
    public void stop() {
    if (thread != null) {
      thread.stop();
      thread = null;
    }
  }

  // Implement java.lang.Runnable.run:
  public void run() {
    while(thread != null && counter<10 ) {
      // repaint() invokes update():
      repaint();
      counter++;
      
      try {
        Thread.sleep(500);
      }
      catch(InterruptedException e) {
        // Do nothing
      };
    }
  }

  // Override java.awt.Component.update:
public void update(Graphics g) {

  // count=+count;
  double nv= randomFG.next(); 
  
  int ar= (int)(nv/0.5);
  bars[ar].setPicked();
  bars[ar].setSize(PGD[ar],nv);

  //System.out.println(nv+  "   "+ar+ "     selected pgd       "+PGD[ar] +  "  BAR hight "+   (int)( PGD[ar]*200)  );
  
  
  /* Get Off Screen Graphics Context */
  Graphics og = image.getGraphics();
  /* fill background */
  og.setColor(getBackground());
  og.clearRect(0,0,getSize().width,getSize().height);
  
  int rank=0;
  
  for(int i=0;i<MAX;i++){
    if (bars[i].picked()) {
      bars[i].setLocation(25*rank);
      bars[i].paint(og);
       og.setColor(Color.black);
      og.drawString(Double.toString(bars[i].getSize()),bars[i].getX() ,bars[i].getY()+10);
      rank++;
    }
  }
  og.drawLine(20,getSize().height/2,20,getSize().height/2-150);

  for (int i=0;i<10;i++) {
    og.drawString(Double.toString(PGD[i]),20,getSize().height/2 - (int)(PGD[i]*200));
  }
    

  paint(g);
}
  

public void paint(Graphics g) {
    g.drawImage(image, 0, 0, this);
  }
}



class RandomFloatingGenerator
{
  int [] selected;
  int counter;
  

public RandomFloatingGenerator(){

  selected = new int[10];
  counter=0;

}
    
public boolean picked(double X)
  {
    for (int i=0 ; i<counter;i++){
      if (selected[i]==X)
	return true;
    }
    return false;
  }
  
      
public  double next() {

  int X=1;
  while(X % 5 !=0 ||  picked(X)){
    X=(int) (Math.random()*50);
  }
     try {
  selected[counter]=X ;
      }
      catch(Exception e) {
	System.out.println("dsfsdf");
	
        System.exit(1);
	
      };
  counter++;
  return (double)X/10.0;
}
}




